// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.transshipment;

/**
 * <p>
 * Transbordement d'un produit (capturé) d'un navire à l'autre.
 * </p>
 * <p>
 * Pour connaitre le navire d'origine des produits (celui qui les
 * possédait avant le transbordement), il faut utiliser les liens
 * vers FishingTrip ou MetaFishingTrip, qui possèdent un lien vers
 * Vessel.
 * </p>
 */
public abstract class Transshipment
    implements java.io.Serializable
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -3685829031633801774L;

    private java.lang.Integer id;

    /**
     * <p>
     * Idenfiant interne. Généré par le système.
     * </p>
     */
    public java.lang.Integer getId()
    {
        return this.id;
    }

    public void setId(java.lang.Integer id)
    {
        this.id = id;
    }

    private java.util.Date transshipmentDateTime;

    /**
     * <p>
     * Rang du transbordement, utilisé quand plusieurs transbordements
     * ont eu lieu le meme jour pour une meme navire, et que l'heure de
     * landingDateTime ne permet pas de distinguer les transbordements
     * entre eux.
     * </p>
     * <p>
     * Utiliser pour SACAPT : l'ordre es alors celui de présence dans
     * le fichier d'origine.
     * </p>
     */
    public java.util.Date getTransshipmentDateTime()
    {
        return this.transshipmentDateTime;
    }

    public void setTransshipmentDateTime(java.util.Date transshipmentDateTime)
    {
        this.transshipmentDateTime = transshipmentDateTime;
    }

    private java.lang.Short rankOrder;

    /**
     * <p>
     * <html>
     * </p>
     * <p>
     * <head>
     * </p>
     * <p>
     * </head>
     * </p>
     * <p>
     * <body>
     * </p>
     * <p>
     * <p>
     * </p>
     * <p>
     * Rang du transbordement, utilis&#233; quand plusieurs
     * transbordements ont
     * </p>
     * <p>
     * eu lieu le meme jour pour une meme navire, et que l'heure de
     * <i>landingDateTime</i>
     * </p>
     * <p>
     * ne permet pas de distinguer les d&#233;barquement entre
     * eux.<br><br>Utiliser
     * </p>
     * <p>
     * pour SACAPT : l'ordre es alors celui de pr&#233;sence dans le
     * fichier
     * </p>
     * <p>
     * d'origine.
     * </p>
     * <p>
     * </p>
     * </p>
     * <p>
     * </body>
     * </p>
     * <p>
     * </html>
     * </p>
     */
    public java.lang.Short getRankOrder()
    {
        return this.rankOrder;
    }

    public void setRankOrder(java.lang.Short rankOrder)
    {
        this.rankOrder = rankOrder;
    }

    private java.lang.String comments;

    /**
     * 
     */
    public java.lang.String getComments()
    {
        return this.comments;
    }

    public void setComments(java.lang.String comments)
    {
        this.comments = comments;
    }

    private java.util.Date creationDate;

    /**
     * 
     */
    public java.util.Date getCreationDate()
    {
        return this.creationDate;
    }

    public void setCreationDate(java.util.Date creationDate)
    {
        this.creationDate = creationDate;
    }

    private java.util.Date controlDate;

    /**
     * 
     */
    public java.util.Date getControlDate()
    {
        return this.controlDate;
    }

    public void setControlDate(java.util.Date controlDate)
    {
        this.controlDate = controlDate;
    }

    private java.util.Date qualificationDate;

    /**
     * 
     */
    public java.util.Date getQualificationDate()
    {
        return this.qualificationDate;
    }

    public void setQualificationDate(java.util.Date qualificationDate)
    {
        this.qualificationDate = qualificationDate;
    }

    private java.lang.String qualificationComments;

    /**
     * 
     */
    public java.lang.String getQualificationComments()
    {
        return this.qualificationComments;
    }

    public void setQualificationComments(java.lang.String qualificationComments)
    {
        this.qualificationComments = qualificationComments;
    }

    private java.sql.Timestamp updateDate;

    /**
     * 
     */
    public java.sql.Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    public void setUpdateDate(java.sql.Timestamp updateDate)
    {
        this.updateDate = updateDate;
    }


    private fr.ifremer.adagio.core.dao.referential.QualityFlag qualityFlag;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.referential.QualityFlag getQualityFlag()
    {
        return this.qualityFlag;
    }

    public void setQualityFlag(fr.ifremer.adagio.core.dao.referential.QualityFlag qualityFlag)
    {
        this.qualityFlag = qualityFlag;
    }


    private fr.ifremer.adagio.core.dao.administration.user.Person recorderPerson;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.administration.user.Person getRecorderPerson()
    {
        return this.recorderPerson;
    }

    public void setRecorderPerson(fr.ifremer.adagio.core.dao.administration.user.Person recorderPerson)
    {
        this.recorderPerson = recorderPerson;
    }


    private fr.ifremer.adagio.core.dao.administration.user.Department recorderDepartment;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.administration.user.Department getRecorderDepartment()
    {
        return this.recorderDepartment;
    }

    public void setRecorderDepartment(fr.ifremer.adagio.core.dao.administration.user.Department recorderDepartment)
    {
        this.recorderDepartment = recorderDepartment;
    }


    private fr.ifremer.adagio.core.dao.data.vessel.Vessel fromVessel;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.data.vessel.Vessel getFromVessel()
    {
        return this.fromVessel;
    }

    public void setFromVessel(fr.ifremer.adagio.core.dao.data.vessel.Vessel fromVessel)
    {
        this.fromVessel = fromVessel;
    }


    private fr.ifremer.adagio.core.dao.administration.programStrategy.Program program;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.administration.programStrategy.Program getProgram()
    {
        return this.program;
    }

    public void setProgram(fr.ifremer.adagio.core.dao.administration.programStrategy.Program program)
    {
        this.program = program;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.data.measure.SurveyMeasurement> surveyMeasurements = new java.util.HashSet<fr.ifremer.adagio.core.dao.data.measure.SurveyMeasurement>();

    /**
     * 
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.data.measure.SurveyMeasurement> getSurveyMeasurements()
    {
        return this.surveyMeasurements;
    }

    public void setSurveyMeasurements(java.util.Collection<fr.ifremer.adagio.core.dao.data.measure.SurveyMeasurement> surveyMeasurements)
    {
        this.surveyMeasurements = surveyMeasurements;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.data.produce.Produce> produces = new java.util.HashSet<fr.ifremer.adagio.core.dao.data.produce.Produce>();

    /**
     * <p>
     * Listes de produits transbordés.
     * </p>
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.data.produce.Produce> getProduces()
    {
        return this.produces;
    }

    public void setProduces(java.util.Collection<fr.ifremer.adagio.core.dao.data.produce.Produce> produces)
    {
        this.produces = produces;
    }


    private fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip fishingTrip;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip getFishingTrip()
    {
        return this.fishingTrip;
    }

    public void setFishingTrip(fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip fishingTrip)
    {
        this.fishingTrip = fishingTrip;
    }


    private fr.ifremer.adagio.core.dao.referential.location.Location transshipmentLocation;

    /**
     * <p>
     * Zone ou port dans lequel se fait le transbordement.
     * </p>
     * <p>
     * Non renseigné dans SACAPT
     * </p>
     */
    public fr.ifremer.adagio.core.dao.referential.location.Location getTransshipmentLocation()
    {
        return this.transshipmentLocation;
    }

    public void setTransshipmentLocation(fr.ifremer.adagio.core.dao.referential.location.Location transshipmentLocation)
    {
        this.transshipmentLocation = transshipmentLocation;
    }


    private fr.ifremer.adagio.core.dao.data.vessel.Vessel toVessel;

    /**
     * <p>
     * Navire vers lequel le transbordement a été réalisé.
     * </p>
     */
    public fr.ifremer.adagio.core.dao.data.vessel.Vessel getToVessel()
    {
        return this.toVessel;
    }

    public void setToVessel(fr.ifremer.adagio.core.dao.data.vessel.Vessel toVessel)
    {
        this.toVessel = toVessel;
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only return <code>true</code> if the argument reference and <code>this</code>
     * refer to the same object.
     */
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof Transshipment))
        {
            return false;
        }
        final Transshipment that = (Transshipment)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (id == null ? 0 : id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link fr.ifremer.adagio.core.dao.data.transshipment.Transshipment}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.data.transshipment.Transshipment}.
         */
        public static fr.ifremer.adagio.core.dao.data.transshipment.Transshipment newInstance()
        {
            final fr.ifremer.adagio.core.dao.data.transshipment.Transshipment entity = new fr.ifremer.adagio.core.dao.data.transshipment.TransshipmentImpl();
			return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.data.transshipment.Transshipment}, taking all required and/or
         * read-only properties as arguments.
         */
        public static fr.ifremer.adagio.core.dao.data.transshipment.Transshipment newInstance(java.util.Date transshipmentDateTime, java.util.Date creationDate, fr.ifremer.adagio.core.dao.referential.QualityFlag qualityFlag, fr.ifremer.adagio.core.dao.administration.user.Department recorderDepartment, fr.ifremer.adagio.core.dao.data.vessel.Vessel fromVessel, fr.ifremer.adagio.core.dao.administration.programStrategy.Program program, fr.ifremer.adagio.core.dao.data.vessel.Vessel toVessel)
        {
            final fr.ifremer.adagio.core.dao.data.transshipment.Transshipment entity = newInstance();
            entity.setTransshipmentDateTime(transshipmentDateTime);
            entity.setCreationDate(creationDate);
            entity.setQualityFlag(qualityFlag);
            entity.setRecorderDepartment(recorderDepartment);
            entity.setFromVessel(fromVessel);
            entity.setProgram(program);
            entity.setToVessel(toVessel);
            return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.data.transshipment.Transshipment}, taking all possible properties
         * (except the identifier(s))as arguments.
         */
        public static fr.ifremer.adagio.core.dao.data.transshipment.Transshipment newInstance(java.util.Date transshipmentDateTime, java.lang.Short rankOrder, java.lang.String comments, java.util.Date creationDate, java.util.Date controlDate, java.util.Date qualificationDate, java.lang.String qualificationComments, java.sql.Timestamp updateDate, fr.ifremer.adagio.core.dao.referential.QualityFlag qualityFlag, fr.ifremer.adagio.core.dao.administration.user.Person recorderPerson, fr.ifremer.adagio.core.dao.administration.user.Department recorderDepartment, fr.ifremer.adagio.core.dao.data.vessel.Vessel fromVessel, fr.ifremer.adagio.core.dao.administration.programStrategy.Program program, java.util.Collection<fr.ifremer.adagio.core.dao.data.measure.SurveyMeasurement> surveyMeasurements, java.util.Collection<fr.ifremer.adagio.core.dao.data.produce.Produce> produces, fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip fishingTrip, fr.ifremer.adagio.core.dao.referential.location.Location transshipmentLocation, fr.ifremer.adagio.core.dao.data.vessel.Vessel toVessel)
        {
            final fr.ifremer.adagio.core.dao.data.transshipment.Transshipment entity = newInstance();
            entity.setTransshipmentDateTime(transshipmentDateTime);
            entity.setRankOrder(rankOrder);
            entity.setComments(comments);
            entity.setCreationDate(creationDate);
            entity.setControlDate(controlDate);
            entity.setQualificationDate(qualificationDate);
            entity.setQualificationComments(qualificationComments);
            entity.setUpdateDate(updateDate);
            entity.setQualityFlag(qualityFlag);
            entity.setRecorderPerson(recorderPerson);
            entity.setRecorderDepartment(recorderDepartment);
            entity.setFromVessel(fromVessel);
            entity.setProgram(program);
            entity.setSurveyMeasurements(surveyMeasurements);
            entity.setProduces(produces);
            entity.setFishingTrip(fishingTrip);
            entity.setTransshipmentLocation(transshipmentLocation);
            entity.setToVessel(toVessel);
            return entity;
        }
    }
    
// Transshipment.java merge-point
}